import { ActionDefinition, ActionPayload, AutomataState, StateDefinition, StateFluentOptions, StateMachineOptions, TypedReducer } from "./common";
import { Node } from "./options";
export declare class Automata<TState> implements StateMachineOptions<TState> {
    protected automataName: string;
    initial: AutomataState<TState>;
    current: AutomataState<TState>;
    private states;
    private options;
    constructor(automataName: string);
    in(state: StateDefinition<TState, ActionPayload>): StateFluentOptions<TState>;
    inAny(): StateFluentOptions<TState>;
    beginWith(state: StateDefinition<TState, any | undefined>): void;
    state<TActionPayload extends ActionPayload = undefined>(name: string, reducer: TypedReducer<TState, TActionPayload>): StateDefinition<TState, TActionPayload>;
    action<TActionPayload extends ActionPayload = undefined>(type: string): ActionDefinition<TActionPayload>;
    getGraph(): Node<TState, ActionPayload>[];
    protected mergeState(state: TState): TState;
}
